-- (c) Copyright 1995-2021 Xilinx, Inc. All rights reserved.
-- 
-- This file contains confidential and proprietary information
-- of Xilinx, Inc. and is protected under U.S. and
-- international copyright and other intellectual property
-- laws.
-- 
-- DISCLAIMER
-- This disclaimer is not a license and does not grant any
-- rights to the materials distributed herewith. Except as
-- otherwise provided in a valid license issued to you by
-- Xilinx, and to the maximum extent permitted by applicable
-- law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
-- WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
-- AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
-- BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
-- INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
-- (2) Xilinx shall not be liable (whether in contract or tort,
-- including negligence, or under any other theory of
-- liability) for any loss or damage of any kind or nature
-- related to, arising under or in connection with these
-- materials, including for any direct, or any indirect,
-- special, incidental, or consequential loss or damage
-- (including loss of data, profits, goodwill, or any type of
-- loss or damage suffered as a result of any action brought
-- by a third party) even if such damage or loss was
-- reasonably foreseeable or Xilinx had been advised of the
-- possibility of the same.
-- 
-- CRITICAL APPLICATIONS
-- Xilinx products are not designed or intended to be fail-
-- safe, or for use in any application requiring fail-safe
-- performance, such as life-support or safety devices or
-- systems, Class III medical devices, nuclear facilities,
-- applications related to the deployment of airbags, or any
-- other applications that could lead to death, personal
-- injury, or severe property or environmental damage
-- (individually and collectively, "Critical
-- Applications"). Customer assumes the sole risk and
-- liability of any use of Xilinx products in Critical
-- Applications, subject only to applicable laws and
-- regulations governing limitations on product liability.
-- 
-- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
-- PART OF THIS FILE AT ALL TIMES.
-- 
-- DO NOT MODIFY THIS FILE.

-- IP VLNV: User_Company:SysGen:sysgen_pwm:1.0
-- IP Revision: 259152995

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;

LIBRARY xil_defaultlib;
USE xil_defaultlib.sysgen_pwm;

ENTITY sysgen_pwm_bd_sysgen_pwm_1_0 IS
  PORT (
    clock_clk_en : IN STD_LOGIC;
    clock_period : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
    clock_prescaler : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
    clock_timer : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
    i_updaterate : IN STD_LOGIC;
    i_nextdutycycle : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
    clk : IN STD_LOGIC;
    o_pwm : OUT STD_LOGIC
  );
END sysgen_pwm_bd_sysgen_pwm_1_0;

ARCHITECTURE sysgen_pwm_bd_sysgen_pwm_1_0_arch OF sysgen_pwm_bd_sysgen_pwm_1_0 IS
  ATTRIBUTE DowngradeIPIdentifiedWarnings : STRING;
  ATTRIBUTE DowngradeIPIdentifiedWarnings OF sysgen_pwm_bd_sysgen_pwm_1_0_arch: ARCHITECTURE IS "yes";
  COMPONENT sysgen_pwm IS
    PORT (
      clock_clk_en : IN STD_LOGIC;
      clock_period : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
      clock_prescaler : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
      clock_timer : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
      i_updaterate : IN STD_LOGIC;
      i_nextdutycycle : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
      clk : IN STD_LOGIC;
      o_pwm : OUT STD_LOGIC
    );
  END COMPONENT sysgen_pwm;
  ATTRIBUTE IP_DEFINITION_SOURCE : STRING;
  ATTRIBUTE IP_DEFINITION_SOURCE OF sysgen_pwm_bd_sysgen_pwm_1_0_arch: ARCHITECTURE IS "sysgen";
  ATTRIBUTE X_INTERFACE_INFO : STRING;
  ATTRIBUTE X_INTERFACE_PARAMETER : STRING;
  ATTRIBUTE X_INTERFACE_PARAMETER OF o_pwm: SIGNAL IS "XIL_INTERFACENAME o_pwm, LAYERED_METADATA xilinx.com:interface:datatypes:1.0 {DATA {datatype {name {attribs {resolve_type immediate dependency {} format string minimum {} maximum {}} value {}} bitwidth {attribs {resolve_type immediate dependency {} format long minimum {} maximum {}} value 1} bitoffset {attribs {resolve_type immediate dependency {} format long minimum {} maximum {}} value 0} real {fixed {fractwidth {attribs {resolve_type immediate dependency {} format long minimum {} maximum {}} " & 
"value 0} signed {attribs {resolve_type immediate dependency {} format bool minimum {} maximum {}} value false}}}}}}";
  ATTRIBUTE X_INTERFACE_INFO OF o_pwm: SIGNAL IS "xilinx.com:signal:data:1.0 o_pwm DATA";
  ATTRIBUTE X_INTERFACE_PARAMETER OF clk: SIGNAL IS "XIL_INTERFACENAME clk, ASSOCIATED_BUSIF clock_clk_en, FREQ_HZ 100000000, FREQ_TOLERANCE_HZ 0, PHASE 0.000, CLK_DOMAIN sysgen_pwm_bd_clk, INSERT_VIP 0";
  ATTRIBUTE X_INTERFACE_INFO OF clk: SIGNAL IS "xilinx.com:signal:clock:1.0 clk CLK";
  ATTRIBUTE X_INTERFACE_PARAMETER OF i_nextdutycycle: SIGNAL IS "XIL_INTERFACENAME i_nextdutycycle, LAYERED_METADATA xilinx.com:interface:datatypes:1.0 {DATA {datatype {name {attribs {resolve_type immediate dependency {} format string minimum {} maximum {}} value {}} bitwidth {attribs {resolve_type immediate dependency {} format long minimum {} maximum {}} value 16} bitoffset {attribs {resolve_type immediate dependency {} format long minimum {} maximum {}} value 0} real {fixed {fractwidth {attribs {resolve_type immediate dependency {} format long minimum {} m" & 
"aximum {}} value 0} signed {attribs {resolve_type immediate dependency {} format bool minimum {} maximum {}} value false}}}}}}";
  ATTRIBUTE X_INTERFACE_INFO OF i_nextdutycycle: SIGNAL IS "xilinx.com:signal:data:1.0 i_nextdutycycle DATA";
  ATTRIBUTE X_INTERFACE_PARAMETER OF i_updaterate: SIGNAL IS "XIL_INTERFACENAME i_updaterate, LAYERED_METADATA xilinx.com:interface:datatypes:1.0 {DATA {datatype {name {attribs {resolve_type immediate dependency {} format string minimum {} maximum {}} value {}} bitwidth {attribs {resolve_type immediate dependency {} format long minimum {} maximum {}} value 1} bitoffset {attribs {resolve_type immediate dependency {} format long minimum {} maximum {}} value 0} real {fixed {fractwidth {attribs {resolve_type immediate dependency {} format long minimum {} maxim" & 
"um {}} value 0} signed {attribs {resolve_type immediate dependency {} format bool minimum {} maximum {}} value false}}}}}}";
  ATTRIBUTE X_INTERFACE_INFO OF i_updaterate: SIGNAL IS "xilinx.com:signal:data:1.0 i_updaterate DATA";
  ATTRIBUTE X_INTERFACE_PARAMETER OF clock_timer: SIGNAL IS "XIL_INTERFACENAME clock_timer, LAYERED_METADATA xilinx.com:interface:datatypes:1.0 {DATA {datatype {name {attribs {resolve_type immediate dependency {} format string minimum {} maximum {}} value {}} bitwidth {attribs {resolve_type immediate dependency {} format long minimum {} maximum {}} value 16} bitoffset {attribs {resolve_type immediate dependency {} format long minimum {} maximum {}} value 0} real {fixed {fractwidth {attribs {resolve_type immediate dependency {} format long minimum {} maxim" & 
"um {}} value 0} signed {attribs {resolve_type immediate dependency {} format bool minimum {} maximum {}} value false}}}}}}";
  ATTRIBUTE X_INTERFACE_INFO OF clock_timer: SIGNAL IS "xilinx.com:signal:data:1.0 clock_timer DATA";
  ATTRIBUTE X_INTERFACE_PARAMETER OF clock_prescaler: SIGNAL IS "XIL_INTERFACENAME clock_prescaler, LAYERED_METADATA xilinx.com:interface:datatypes:1.0 {DATA {datatype {name {attribs {resolve_type immediate dependency {} format string minimum {} maximum {}} value {}} bitwidth {attribs {resolve_type immediate dependency {} format long minimum {} maximum {}} value 16} bitoffset {attribs {resolve_type immediate dependency {} format long minimum {} maximum {}} value 0} real {fixed {fractwidth {attribs {resolve_type immediate dependency {} format long minimum {} m" & 
"aximum {}} value 0} signed {attribs {resolve_type immediate dependency {} format bool minimum {} maximum {}} value false}}}}}}";
  ATTRIBUTE X_INTERFACE_INFO OF clock_prescaler: SIGNAL IS "xilinx.com:signal:data:1.0 clock_prescaler DATA";
  ATTRIBUTE X_INTERFACE_PARAMETER OF clock_period: SIGNAL IS "XIL_INTERFACENAME clock_period, LAYERED_METADATA xilinx.com:interface:datatypes:1.0 {DATA {datatype {name {attribs {resolve_type immediate dependency {} format string minimum {} maximum {}} value {}} bitwidth {attribs {resolve_type immediate dependency {} format long minimum {} maximum {}} value 16} bitoffset {attribs {resolve_type immediate dependency {} format long minimum {} maximum {}} value 0} real {fixed {fractwidth {attribs {resolve_type immediate dependency {} format long minimum {} maxi" & 
"mum {}} value 0} signed {attribs {resolve_type immediate dependency {} format bool minimum {} maximum {}} value false}}}}}}";
  ATTRIBUTE X_INTERFACE_INFO OF clock_period: SIGNAL IS "xilinx.com:signal:data:1.0 clock_period DATA";
  ATTRIBUTE X_INTERFACE_PARAMETER OF clock_clk_en: SIGNAL IS "XIL_INTERFACENAME clock_clk_en, FREQ_HZ 100000000, FREQ_TOLERANCE_HZ 0, PHASE 0.000, CLK_DOMAIN sysgen_pwm_bd_clock_clk_en, INSERT_VIP 0";
  ATTRIBUTE X_INTERFACE_INFO OF clock_clk_en: SIGNAL IS "xilinx.com:signal:clock:1.0 clock_clk_en CLK";
BEGIN
  U0 : sysgen_pwm
    PORT MAP (
      clock_clk_en => clock_clk_en,
      clock_period => clock_period,
      clock_prescaler => clock_prescaler,
      clock_timer => clock_timer,
      i_updaterate => i_updaterate,
      i_nextdutycycle => i_nextdutycycle,
      clk => clk,
      o_pwm => o_pwm
    );
END sysgen_pwm_bd_sysgen_pwm_1_0_arch;
