-- Generated from Simulink block PN161_SysGen_PWM/SYSGEN_PWM_struct
library IEEE;
use IEEE.std_logic_1164.all;
library xil_defaultlib;
use xil_defaultlib.conv_pkg.all;
entity sysgen_pwm_struct is
  port (
    clock_clk_en : in std_logic_vector( 1-1 downto 0 );
    clock_period : in std_logic_vector( 16-1 downto 0 );
    clock_prescaler : in std_logic_vector( 16-1 downto 0 );
    clock_timer : in std_logic_vector( 16-1 downto 0 );
    i_updaterate : in std_logic_vector( 1-1 downto 0 );
    i_nextdutycycle : in std_logic_vector( 16-1 downto 0 );
    clk_1 : in std_logic;
    ce_1 : in std_logic;
    o_pwm : out std_logic_vector( 1-1 downto 0 )
  );
end sysgen_pwm_struct;
architecture structural of sysgen_pwm_struct is 
  signal mcode_rst_net : std_logic_vector( 1-1 downto 0 );
  signal relational1_op_net : std_logic_vector( 1-1 downto 0 );
  signal logical_y_net : std_logic_vector( 1-1 downto 0 );
  signal convert1_dout_net : std_logic_vector( 1-1 downto 0 );
  signal convert_dout_net : std_logic_vector( 1-1 downto 0 );
  signal mcode_up_net : std_logic_vector( 1-1 downto 0 );
  signal clockenable : std_logic_vector( 1-1 downto 0 );
  signal carrier : std_logic_vector( 16-1 downto 0 );
  signal relational2_op_net : std_logic_vector( 1-1 downto 0 );
  signal constant1_op_net : std_logic_vector( 16-1 downto 0 );
  signal register6_q_net : std_logic_vector( 16-1 downto 0 );
  signal addsub1_s_net : std_logic_vector( 17-1 downto 0 );
  signal constant4_op_net : std_logic_vector( 16-1 downto 0 );
  signal constant3_op_net : std_logic_vector( 16-1 downto 0 );
  signal constant2_op_net : std_logic_vector( 16-1 downto 0 );
  signal shift_op_net : std_logic_vector( 16-1 downto 0 );
  signal addsub_s_net : std_logic_vector( 17-1 downto 0 );
  signal clock_clk_en_net : std_logic_vector( 1-1 downto 0 );
  signal clock_period_net : std_logic_vector( 16-1 downto 0 );
  signal clock_timer_net : std_logic_vector( 16-1 downto 0 );
  signal clock_prescaler_net : std_logic_vector( 16-1 downto 0 );
  signal i_updaterate_net : std_logic_vector( 1-1 downto 0 );
  signal i_nextdutycycle_net : std_logic_vector( 16-1 downto 0 );
  signal pwm : std_logic_vector( 1-1 downto 0 );
  signal clk_net : std_logic;
  signal ce_net : std_logic;
  signal clocktimer : std_logic_vector( 16-1 downto 0 );
  signal register3_q_net : std_logic_vector( 17-1 downto 0 );
  signal relational_op_net : std_logic_vector( 1-1 downto 0 );
  signal relational3_op_net : std_logic_vector( 1-1 downto 0 );
  signal register7_q_net : std_logic_vector( 1-1 downto 0 );
  signal logical2_y_net : std_logic_vector( 1-1 downto 0 );
  signal logical1_y_net : std_logic_vector( 1-1 downto 0 );
  signal updateddutycycle : std_logic_vector( 16-1 downto 0 );
  signal clockperiod : std_logic_vector( 16-1 downto 0 );
  signal dutycycleplusone : std_logic_vector( 17-1 downto 0 );
begin
  clock_clk_en_net <= clock_clk_en;
  clock_period_net <= clock_period;
  clock_prescaler_net <= clock_prescaler;
  clock_timer_net <= clock_timer;
  i_updaterate_net <= i_updaterate;
  i_nextdutycycle_net <= i_nextdutycycle;
  o_pwm <= pwm;
  clk_net <= clk_1;
  ce_net <= ce_1;
  addsub : entity xil_defaultlib.sysgen_pwm_xladdsub 
  generic map (
    a_arith => xlUnsigned,
    a_bin_pt => 0,
    a_width => 16,
    b_arith => xlUnsigned,
    b_bin_pt => 0,
    b_width => 16,
    c_has_c_out => 0,
    c_latency => 0,
    c_output_width => 17,
    core_name0 => "sysgen_pwm_c_addsub_v12_0_i0",
    extra_registers => 0,
    full_s_arith => 2,
    full_s_width => 17,
    latency => 0,
    overflow => 1,
    quantization => 1,
    s_arith => xlSigned,
    s_bin_pt => 0,
    s_width => 17
  )
  port map (
    clr => '0',
    en => "1",
    a => shift_op_net,
    b => constant2_op_net,
    clk => clk_net,
    ce => ce_net,
    s => addsub_s_net
  );
  addsub1 : entity xil_defaultlib.sysgen_pwm_xladdsub 
  generic map (
    a_arith => xlUnsigned,
    a_bin_pt => 0,
    a_width => 16,
    b_arith => xlUnsigned,
    b_bin_pt => 0,
    b_width => 16,
    c_has_c_out => 0,
    c_latency => 0,
    c_output_width => 17,
    core_name0 => "sysgen_pwm_c_addsub_v12_0_i1",
    extra_registers => 0,
    full_s_arith => 1,
    full_s_width => 17,
    latency => 0,
    overflow => 1,
    quantization => 1,
    s_arith => xlUnsigned,
    s_bin_pt => 0,
    s_width => 17
  )
  port map (
    clr => '0',
    en => "1",
    a => register6_q_net,
    b => constant4_op_net,
    clk => clk_net,
    ce => ce_net,
    s => addsub1_s_net
  );
  constant1 : entity xil_defaultlib.sysgen_constant_ff37f5feb3 
  port map (
    clk => '0',
    ce => '0',
    clr => '0',
    op => constant1_op_net
  );
  constant2 : entity xil_defaultlib.sysgen_constant_afddf447b3 
  port map (
    clk => '0',
    ce => '0',
    clr => '0',
    op => constant2_op_net
  );
  constant3 : entity xil_defaultlib.sysgen_constant_ff37f5feb3 
  port map (
    clk => '0',
    ce => '0',
    clr => '0',
    op => constant3_op_net
  );
  constant4 : entity xil_defaultlib.sysgen_constant_afddf447b3 
  port map (
    clk => '0',
    ce => '0',
    clr => '0',
    op => constant4_op_net
  );
  convert : entity xil_defaultlib.sysgen_pwm_xlconvert 
  generic map (
    bool_conversion => 1,
    din_arith => 1,
    din_bin_pt => 0,
    din_width => 1,
    dout_arith => 1,
    dout_bin_pt => 0,
    dout_width => 1,
    latency => 0,
    overflow => xlWrap,
    quantization => xlTruncate
  )
  port map (
    clr => '0',
    en => "1",
    din => mcode_up_net,
    clk => clk_net,
    ce => ce_net,
    dout => convert_dout_net
  );
  convert1 : entity xil_defaultlib.sysgen_pwm_xlconvert 
  generic map (
    bool_conversion => 1,
    din_arith => 1,
    din_bin_pt => 0,
    din_width => 1,
    dout_arith => 1,
    dout_bin_pt => 0,
    dout_width => 1,
    latency => 0,
    overflow => xlWrap,
    quantization => xlTruncate
  )
  port map (
    clr => '0',
    en => "1",
    din => mcode_rst_net,
    clk => clk_net,
    ce => ce_net,
    dout => convert1_dout_net
  );
  counter : entity xil_defaultlib.sysgen_pwm_xlcounter_free 
  generic map (
    core_name0 => "sysgen_pwm_c_counter_binary_v12_0_i0",
    op_arith => xlUnsigned,
    op_width => 16
  )
  port map (
    clr => '0',
    up => convert_dout_net,
    rst => convert1_dout_net,
    en => clockenable,
    clk => clk_net,
    ce => ce_net,
    op => carrier
  );
  logical : entity xil_defaultlib.sysgen_logical_7ed1c454d6 
  port map (
    clk => '0',
    ce => '0',
    clr => '0',
    d0 => relational1_op_net,
    d1 => relational2_op_net,
    y => logical_y_net
  );
  logical1 : entity xil_defaultlib.sysgen_logical_05f0f46b0c 
  port map (
    clk => '0',
    ce => '0',
    clr => '0',
    d0 => relational_op_net,
    d1 => logical2_y_net,
    y => logical1_y_net
  );
  logical2 : entity xil_defaultlib.sysgen_logical_7ed1c454d6 
  port map (
    clk => '0',
    ce => '0',
    clr => '0',
    d0 => relational3_op_net,
    d1 => register7_q_net,
    y => logical2_y_net
  );
  mcode : entity xil_defaultlib.sysgen_mcode_block_786c4511b6 
  port map (
    clr => '0',
    reg_halfperiodminusone => register3_q_net,
    reg_timer => clocktimer,
    clk => clk_net,
    ce => ce_net,
    up => mcode_up_net,
    rst => mcode_rst_net
  );
  register_x0 : entity xil_defaultlib.sysgen_pwm_xlregister 
  generic map (
    d_width => 16,
    init_value => b"0000000000000000"
  )
  port map (
    rst => "0",
    d => register6_q_net,
    en => logical1_y_net,
    clk => clk_net,
    ce => ce_net,
    q => updateddutycycle
  );
  register1 : entity xil_defaultlib.sysgen_pwm_xlregister 
  generic map (
    d_width => 16,
    init_value => b"0000000000000000"
  )
  port map (
    en => "1",
    rst => "0",
    d => clock_timer_net,
    clk => clk_net,
    ce => ce_net,
    q => clocktimer
  );
  register2 : entity xil_defaultlib.sysgen_pwm_xlregister 
  generic map (
    d_width => 1,
    init_value => b"0"
  )
  port map (
    en => "1",
    rst => "0",
    d => clock_clk_en_net,
    clk => clk_net,
    ce => ce_net,
    q => clockenable
  );
  register3 : entity xil_defaultlib.sysgen_pwm_xlregister 
  generic map (
    d_width => 17,
    init_value => b"00000000000000000"
  )
  port map (
    en => "1",
    rst => "0",
    d => addsub_s_net,
    clk => clk_net,
    ce => ce_net,
    q => register3_q_net
  );
  register4 : entity xil_defaultlib.sysgen_pwm_xlregister 
  generic map (
    d_width => 17,
    init_value => b"00000000000000000"
  )
  port map (
    rst => "0",
    d => addsub1_s_net,
    en => logical1_y_net,
    clk => clk_net,
    ce => ce_net,
    q => dutycycleplusone
  );
  register5 : entity xil_defaultlib.sysgen_pwm_xlregister 
  generic map (
    d_width => 1,
    init_value => b"0"
  )
  port map (
    en => "1",
    rst => "0",
    d => logical_y_net,
    clk => clk_net,
    ce => ce_net,
    q => pwm
  );
  register6 : entity xil_defaultlib.sysgen_pwm_xlregister 
  generic map (
    d_width => 16,
    init_value => b"0000000000000000"
  )
  port map (
    en => "1",
    rst => "0",
    d => i_nextdutycycle_net,
    clk => clk_net,
    ce => ce_net,
    q => register6_q_net
  );
  register7 : entity xil_defaultlib.sysgen_pwm_xlregister 
  generic map (
    d_width => 1,
    init_value => b"0"
  )
  port map (
    en => "1",
    rst => "0",
    d => i_updaterate_net,
    clk => clk_net,
    ce => ce_net,
    q => register7_q_net
  );
  register8 : entity xil_defaultlib.sysgen_pwm_xlregister 
  generic map (
    d_width => 16,
    init_value => b"0000000000000000"
  )
  port map (
    en => "1",
    rst => "0",
    d => clock_period_net,
    clk => clk_net,
    ce => ce_net,
    q => clockperiod
  );
  relational : entity xil_defaultlib.sysgen_relational_fc68cd6ba4 
  port map (
    clk => '0',
    ce => '0',
    clr => '0',
    a => carrier,
    b => constant3_op_net,
    op => relational_op_net
  );
  relational1 : entity xil_defaultlib.sysgen_relational_35677128b0 
  port map (
    clk => '0',
    ce => '0',
    clr => '0',
    a => updateddutycycle,
    b => constant1_op_net,
    op => relational1_op_net
  );
  relational2 : entity xil_defaultlib.sysgen_relational_44491679f1 
  port map (
    clk => '0',
    ce => '0',
    clr => '0',
    a => dutycycleplusone,
    b => carrier,
    op => relational2_op_net
  );
  relational3 : entity xil_defaultlib.sysgen_relational_fc68cd6ba4 
  port map (
    clk => '0',
    ce => '0',
    clr => '0',
    a => carrier,
    b => clockperiod,
    op => relational3_op_net
  );
  shift : entity xil_defaultlib.sysgen_shift_9eba437164 
  port map (
    clr => '0',
    ip => clock_period_net,
    clk => clk_net,
    ce => ce_net,
    op => shift_op_net
  );
end structural;
-- Generated from Simulink block 
library IEEE;
use IEEE.std_logic_1164.all;
library xil_defaultlib;
use xil_defaultlib.conv_pkg.all;
entity sysgen_pwm_default_clock_driver is
  port (
    sysgen_pwm_sysclk : in std_logic;
    sysgen_pwm_sysce : in std_logic;
    sysgen_pwm_sysclr : in std_logic;
    sysgen_pwm_clk1 : out std_logic;
    sysgen_pwm_ce1 : out std_logic
  );
end sysgen_pwm_default_clock_driver;
architecture structural of sysgen_pwm_default_clock_driver is 
begin
  clockdriver : entity xil_defaultlib.xlclockdriver 
  generic map (
    period => 1,
    log_2_period => 1
  )
  port map (
    sysclk => sysgen_pwm_sysclk,
    sysce => sysgen_pwm_sysce,
    sysclr => sysgen_pwm_sysclr,
    clk => sysgen_pwm_clk1,
    ce => sysgen_pwm_ce1
  );
end structural;
-- Generated from Simulink block 
library IEEE;
use IEEE.std_logic_1164.all;
library xil_defaultlib;
use xil_defaultlib.conv_pkg.all;
entity sysgen_pwm is
  port (
    clock_clk_en : in std_logic;
    clock_period : in std_logic_vector( 16-1 downto 0 );
    clock_prescaler : in std_logic_vector( 16-1 downto 0 );
    clock_timer : in std_logic_vector( 16-1 downto 0 );
    i_updaterate : in std_logic;
    i_nextdutycycle : in std_logic_vector( 16-1 downto 0 );
    clk : in std_logic;
    o_pwm : out std_logic
  );
end sysgen_pwm;
architecture structural of sysgen_pwm is 
  attribute core_generation_info : string;
  attribute core_generation_info of structural : architecture is "sysgen_pwm,sysgen_core_2020_2,{,compilation=IP Catalog,block_icon_display=Default,family=zynq,part=xc7z030,speed=-3,package=fbg676,synthesis_language=vhdl,hdl_library=xil_defaultlib,synthesis_strategy=Vivado Synthesis Defaults,implementation_strategy=Vivado Implementation Defaults,testbench=0,interface_doc=0,ce_clr=0,clock_period=4,system_simulink_period=4e-09,waveform_viewer=0,axilite_interface=0,ip_catalog_plugin=0,hwcosim_burst_mode=0,simulation_time=0.0002,addsub=2,constant=4,convert=2,counter=1,logical=3,mcode=1,register=9,relational=4,shift=1,}";
  signal clk_1_net : std_logic;
  signal ce_1_net : std_logic;
begin
  sysgen_pwm_default_clock_driver : entity xil_defaultlib.sysgen_pwm_default_clock_driver 
  port map (
    sysgen_pwm_sysclk => clk,
    sysgen_pwm_sysce => '1',
    sysgen_pwm_sysclr => '0',
    sysgen_pwm_clk1 => clk_1_net,
    sysgen_pwm_ce1 => ce_1_net
  );
  sysgen_pwm_struct : entity xil_defaultlib.sysgen_pwm_struct 
  port map (
    clock_clk_en(0) => clock_clk_en,
    clock_period => clock_period,
    clock_prescaler => clock_prescaler,
    clock_timer => clock_timer,
    i_updaterate(0) => i_updaterate,
    i_nextdutycycle => i_nextdutycycle,
    clk_1 => clk_1_net,
    ce_1 => ce_1_net,
    o_pwm(0) => o_pwm
  );
end structural;
